# Directus Plugins

Hier sind die selbst entwickelten Plugins für [Directus](https://directus.io).
Directus bietet für Plugins eine [Anleitung](https://docs.directus.io/extensions/introduction.html)
sowie vorgefertigte [Komponenten](https://components.directus.io).

Liste an Plugins:
- `tasks`: Ein Layout für die Task-Liste.  
  Diese soll die Übersicht der Aufgaben vereinfachen und funktioniert auch Mobil.

## Entwicklung

Um die Entwicklung einfach und einheitlich zu gestalten, benutzen wir
[Devcontainer](https://containers.dev) in
[VSCode](https://code.visualstudio.com). Wenn du das Repo in VSCode mit der
Devcontainer-Erweiterung öffnest, dann werden alle Tools und Erweiterungen für
die Entwicklung automatisch für dich installiert. Wenn du das nicht willst oder
kannst, musst du Node von Hand installieren.

Folgende VSCode-Tasks sind definiert:
- `install`: Installiert/Updated die Dependencies
- `dev`: Startet ein lokales Directus und überwacht auf Code-Änderungen
- `build`: Buildet das Plugin

Das lokale Directus ist unter `http://localhost:8055` erreichbar
und es sind bereits Testdaten angelegt (deshalb die DB im Repo).
Der Account ist `admin@example.com` mit dem Passwort `admin`.

## Änderungen

Wenn du etwas ändern willst oder du einen Fehler bemerkt hast, dann öffne gerne
ein [Issue](https://git.swablab.de/swablab/directus/issues) und beschreibe
möglichst genau dein Problem.

Alternativ kannst du die Änderung auch gerne selbst entwickeln und einen
[Pull Request](https://git.swablab.de/swablab/directus/pulls) stellen.

## Deployment

Wenn Änderungen den `main`-Branch erreichen, wird automatisch eine
[Pipeline](https://git.swablab.de/swablab/directus/actions) gestartet. Diese baut
die Erweiterung und fügt diese in das Directus-Image hinzu. Das Image wird dann als
[Package](https://git.swablab.de/swablab/directus/packages) gepuhst und dann
automatisch von Watchtower regelmäßig aktualisiert.